VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   2355
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   3015
   LinkTopic       =   "Form1"
   ScaleHeight     =   2355
   ScaleWidth      =   3015
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text1 
      Height          =   1695
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   2775
   End
   Begin VB.CommandButton Command1 
      Caption         =   "SafeArray ermitteln"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   1920
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function VarPtrArray Lib "msvbvm50.dll" _
        Alias "VarPtr" (Ptr() As Any) As Long

'Private Declare Function VarPtrArray Lib "msvbvm60.dll" _
'        Alias "VarPtr" (Ptr() As Any) As Long
        
Private Declare Sub CopyMemory Lib "kernel32" Alias _
        "RtlMoveMemory" (pDst As Any, pSrc As Any, _
        ByVal ByteLen As Long)
        
'Die Bounds fr das SafeArray
Private Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

'Das SafeArray, eindimensional
Private Type SAFEARRAY1D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 0) As SAFEARRAYBOUND
End Type

'Konstanten fr fFeatures, hier nur zur Anschauung
Const FADF_AUTO = &H1
Const FADF_STATIC = &H2
Const FADF_EMBEDDED = &H4
Const FADF_FIXEDSIZE = &H10
Const FADF_RECORD = &H20
Const FADF_HAVEIID = &H40
Const FADF_HAVEVARTYPE = &H80
Const FADF_BSTR = &H100
Const FADF_UNKNOWN = &H200
Const FADF_DISPATCH = &H400
Const FADF_VARIANT = &H800

Private Sub Command1_Click()
  Call GetSafeArray
End Sub

'Ermittelt und kopiert ein SafeArray
Private Sub GetSafeArray()
  Dim MyArray() As Long
  Dim SafeArray As SAFEARRAY1D
  Dim PointerToPointer As Long
  Dim PointerToSafeArray As Long
      
    'Feld dimensionieren
    ReDim MyArray(10 To 25)
     
    'Ersten Zeiger ermitteln
    PointerToPointer = VarPtrArray(MyArray)
    
    'Zweiten Zeiger auslesen
    Call CopyMemory(PointerToSafeArray, _
                    ByVal PointerToPointer, 4&)
                        
    'SafeArray in vorgegebene Strukur kopieren
    Call CopyMemory(SafeArray, _
                    ByVal PointerToSafeArray, _
                    Len(SafeArray))
          
    'Resultat ausgeben
    Call DisplaySafeArray(SafeArray)
End Sub

'Ausgabe der Struktur
Private Sub DisplaySafeArray(SA As SAFEARRAY1D)
  Dim H As String
      
    H = ".cDims = " & SA.cDims & vbCrLf
    H = H & ".fFeatures = " & SA.fFeatures & vbCrLf
    H = H & ".cbElements = " & SA.cbElements & vbCrLf
    H = H & ".cLocks = " & SA.cLocks & vbCrLf
    H = H & ".pvData = " & SA.pvData & vbCrLf
    
    H = H & ".Bounds(0).cElements = " & _
            SA.Bounds(0).cElements & vbCrLf
            
    H = H & ".Bounds(0).lLbound = " & _
            SA.Bounds(0).lLbound & vbCrLf
        
    Text1.Text = H
End Sub
