VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   4230
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   4230
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command2 
      Caption         =   "Zurcksetzen"
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   3840
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Bild schrfen"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   3840
      Width           =   1335
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   3675
      Left            =   120
      ScaleHeight     =   241
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   483
      TabIndex        =   0
      Top             =   120
      Width           =   7305
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   3675
      Left            =   120
      ScaleHeight     =   241
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   483
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   7305
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Der Tip wird erst zur .exe kompiliert zum wahren Genu!
'Es ist vorab sicherzustellen, da auf dem System eine
'Farb-Auflsung von mindestens 24-Bit eingestellt ist.

Option Explicit

Private Declare Function GetObject Lib "gdi32" Alias _
        "GetObjectA" (ByVal hObject As Long, ByVal nCount As _
        Long, lpObject As Any) As Long

Private Declare Function VarPtrArray Lib "msvbvm50.dll" Alias _
        "VarPtr" (Ptr() As Any) As Long

'Private Declare Function VarPtrArray Lib "msvbvm60.dll" _
'        Alias "VarPtr" (Ptr() As Any) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias _
        "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal _
        ByteLen As Long)

Private Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Private Type SAFEARRAY2D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Private Sub Form_Load()
  Call ResetBitmap
End Sub

Private Sub Command1_Click()
  Call MakeBitmap
End Sub

Private Sub Command2_Click()
  Call ResetBitmap
End Sub

Private Sub MakeBitmap()
  Dim Pic() As Byte, PicBuff() As Byte
  Dim SafeArray As SAFEARRAY2D
  Dim SafeArrayBuffer As SAFEARRAY2D
  Dim Bmp As BITMAP, BmpBuffer As BITMAP
  Dim x As Long, y As Long, Temp As Long
    
    'Auslesen der BITMAP Strukur der beiden PictureBoxen
    Call GetObject(Picture1.Picture, Len(Bmp), Bmp)
    Call GetObject(Picture2.Picture, Len(BmpBuffer), BmpBuffer)
  
    'berprfung ob eine 24-Bit Auflsung mglich ist.
    If Bmp.bmBitsPixel <> 24 Then
      MsgBox "Es werden nur 24-Bit Bitmaps untersttzt!"
      Exit Sub
    End If
    
    MousePointer = vbHourglass
    
    'Deskriptor des Bytearrays dem die sichtbare
    'PictureBox (Picture1) zugeordnet wird.
    With SafeArray
      .cDims = 2
      .fFeatures = 0
      .cbElements = 1
      .cLocks = 0
      .pvData = Bmp.bmBits
      
      .Bounds(0).lLbound = 0
      .Bounds(0).cElements = Bmp.bmHeight
      
      .Bounds(1).lLbound = 0
      .Bounds(1).cElements = Bmp.bmWidthBytes
    End With
        
    'Deskriptor des Bytearrays dem die unsichtbare
    'PictureBox (Picture2) zwecks Pufferung zugeordnet wird.
    With SafeArrayBuffer
      .cDims = 2
      .fFeatures = 0
      .cbElements = 1
      .cLocks = 0
      .pvData = BmpBuffer.bmBits
      
      .Bounds(0).lLbound = 0
      .Bounds(0).cElements = BmpBuffer.bmHeight
      
      .Bounds(1).lLbound = 0
      .Bounds(1).cElements = BmpBuffer.bmWidthBytes
    End With
    
    'Zuweisung der beiden neuen Deskriptoren
    Call CopyMemory(ByVal VarPtrArray(Pic), _
                    VarPtr(SafeArray), 4&)
                    
    Call CopyMemory(ByVal VarPtrArray(PicBuff), _
                    VarPtr(SafeArrayBuffer), 4&)

    'Der eigentliche Algorithmus des Schrfens
    For x = 3 To UBound(Pic, 1) - 3
      For y = 0 To UBound(Pic, 2)
        Temp = (CInt(PicBuff(x, y)) + 0.5 * (CInt(PicBuff(x, y)) _
                - CInt(PicBuff(x - 3, y))))
                
        If Temp > 255 Then Temp = 255
        If Temp < 0 Then Temp = 0
        Pic(x, y) = Temp
      Next y
    Next x

    'Zurcksetzen der verbogenen Deskriptoren.
    Call CopyMemory(ByVal VarPtrArray(Pic), 0&, 4&)
    Call CopyMemory(ByVal VarPtrArray(PicBuff), 0&, 4&)
    
    'Array aus dem Image in das Picture holen
    Picture1.Refresh
    
    MousePointer = vbDefault
End Sub

Private Sub ResetBitmap()
  Picture1.Picture = LoadPicture(App.Path & "\Bild.jpg")
  Picture2.Picture = LoadPicture(App.Path & "\Bild.jpg")
End Sub
