VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   4305
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   4305
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar HScroll2 
      Height          =   195
      LargeChange     =   20
      Left            =   960
      Max             =   200
      SmallChange     =   5
      TabIndex        =   3
      Top             =   4080
      Value           =   90
      Width           =   6375
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   195
      LargeChange     =   20
      Left            =   960
      Max             =   200
      SmallChange     =   5
      TabIndex        =   2
      Top             =   3840
      Value           =   90
      Width           =   6375
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   3675
      Left            =   120
      ScaleHeight     =   241
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   483
      TabIndex        =   0
      Top             =   120
      Width           =   7305
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   3675
      Left            =   120
      ScaleHeight     =   241
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   483
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   7305
   End
   Begin VB.Label Label2 
      Caption         =   "Helligkeit"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   3840
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Kontrast"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   4080
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Der Tip wird erst zur .exe kompiliert zum wahren Genu!
'Es ist vorab sicherzustellen, da auf dem System eine
'Farb-Auflsung von mindestens 24-Bit eingestellt ist.

Option Explicit

Private Declare Function GetObject Lib "gdi32" Alias _
        "GetObjectA" (ByVal hObject As Long, ByVal nCount As _
        Long, lpObject As Any) As Long

Private Declare Function VarPtrArray Lib "msvbvm50.dll" Alias _
        "VarPtr" (Ptr() As Any) As Long

'Private Declare Function VarPtrArray Lib "msvbvm60.dll" _
'        Alias "VarPtr" (Ptr() As Any) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias _
        "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal _
        ByteLen As Long)

Private Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Private Type SAFEARRAY2D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Dim Brightness As Single, Contrast As Single
Dim TableBright(255) As Byte


Private Sub Form_Load()
  Picture1.Picture = LoadPicture(App.Path & "\Bild.jpg")
  Picture2.Picture = LoadPicture(App.Path & "\Bild.jpg")
End Sub

Private Sub HScroll1_Change()
  Dim x%, Temp!
  
    Brightness = Exp(HScroll1.Value / 50) / 5 - 0.2

    For x = 0 To 255
      Temp = x * Brightness
      If Temp > 255 Then Temp = 255
      TableBright(x) = Temp
    Next
    
    Call MakeBitmap
    Picture1.Refresh
End Sub

Private Sub HScroll2_Change()
  Dim x As Long, Temp As Single
  
    'Berechnen der Multiplikatoren
    Contrast = Exp(HScroll2.Value / 30) / 20 - 0.05

    For x = 0 To 255
      Temp = ((x - 127) * Contrast) + 127
      If Temp > 255 Then Temp = 255
      If Temp < 0 Then Temp = 0
      TableBright(x) = Temp
    Next x
    
    Call MakeBitmap
End Sub

Private Sub MakeBitmap()
  Dim Pic() As Byte, PicBuff() As Byte
  Dim SafeArray As SAFEARRAY2D
  Dim SafeArrayBuffer As SAFEARRAY2D
  Dim Bmp As BITMAP, BmpBuffer As BITMAP
  Dim x As Long, y As Long
    
    'Auslesen der BITMAP Strukur der beiden PictureBoxen
    Call GetObject(Picture1.Picture, Len(Bmp), Bmp)
    Call GetObject(Picture2.Picture, Len(BmpBuffer), BmpBuffer)
  
    'berprfung ob eine 24-Bit Auflsung mglich ist.
    If Bmp.bmBitsPixel <> 24 Then
      MsgBox "Es werden nur 24-Bit Bitmaps untersttzt!"
      Exit Sub
    End If
    
    MousePointer = vbHourglass
    
    'Deskriptor des Bytearrays dem die sichtbare
    'PictureBox (Picture1) zugeordnet wird.
    With SafeArray
      .cDims = 2
      .fFeatures = 0
      .cbElements = 1
      .cLocks = 0
      .pvData = Bmp.bmBits
      
      .Bounds(0).lLbound = 0
      .Bounds(0).cElements = Bmp.bmHeight
      
      .Bounds(1).lLbound = 0
      .Bounds(1).cElements = Bmp.bmWidthBytes
    End With
        
    'Deskriptor des Bytearrays dem die unsichtbare
    'PictureBox (Picture2) zwecks Pufferung zugeordnet wird.
    With SafeArrayBuffer
      .cDims = 2
      .fFeatures = 0
      .cbElements = 1
      .cLocks = 0
      .pvData = BmpBuffer.bmBits
      
      .Bounds(0).lLbound = 0
      .Bounds(0).cElements = BmpBuffer.bmHeight
      
      .Bounds(1).lLbound = 0
      .Bounds(1).cElements = BmpBuffer.bmWidthBytes
    End With
    
    'Zuweisung der beiden neuen Deskriptoren
    Call CopyMemory(ByVal VarPtrArray(Pic), _
                    VarPtr(SafeArray), 4&)
                    
    Call CopyMemory(ByVal VarPtrArray(PicBuff), _
                    VarPtr(SafeArrayBuffer), 4&)

    'Der eigentliche Algorithmus des Effektes
    For x = 0 To UBound(Pic, 1)
      For y = 0 To UBound(Pic, 2)
        Pic(x, y) = TableBright(PicBuff(x, y))
      Next y
    Next x

    'Zurcksetzen der verbogenen Deskriptoren.
    Call CopyMemory(ByVal VarPtrArray(Pic), 0&, 4&)
    Call CopyMemory(ByVal VarPtrArray(PicBuff), 0&, 4&)
    
    'Array aus dem Image in das Picture holen
    Picture1.Refresh
    
    MousePointer = vbDefault
End Sub
